unit uGeneral;

interface
uses
  sysutils
  ,JanXMLParser2      // Part of EasyXML 2.1
  ;
Const
  VirtualDisplayTag = '$$DISPNAME$$\';

  Function GetNodeByName(aName:String;aNodeList:TJanXMLNodeList2):TjanXMLNode2;
  Function GetOrCreateNodeByName(aName:String;aNodeList:TJanXMLNodeList2;aDefaultValue:String = ''):TjanXMLNode2;
  function GetNextParam(var param:String):String;
  Function MAX(s:String;L:integer):String;
  function GetParam(paramnum:Integer;param:String):String;

implementation


// function to maximize a string to a certain length
Function MAX(s:String;L:integer):String;
Begin
  Result := s;
  while length(result)<l do result := result + ' ';
End;

// strip the next parameter from a string till a ',' comes along
function GetNextParam(var param:String):String;
var
  tmp : String;
Begin
  tmp := '';
  While (length(param)>0) and (param[1]<>',') do
    Begin
      tmp := tmp + param[1];
      delete(param,1,1);
    End;
  delete(param,1,1);
  Result := tmp;
End;

function GetParam(paramnum:Integer;param:String):String;
var
  tmp : String;
  curpar : Integer;
Begin
  tmp := '';
  Curpar := 1;
  if (length(param)>0) and (param[1]=',') then
    delete(param,1,1);

  While (length(param)>0) and (curpar<=paramnum) do
    Begin
      if param[1]=',' then
        inc(curpar)
      else
        if curpar=paramnum then
          tmp := tmp + param[1];
      delete(param,1,1);
    End;
  Result := tmp;
  if pos(VirtualDisplayTag,result)>0 then
    Result := copy(Result,1,pos(VirtualDisplayTag,result)-1);
End;


Function GetNodeByName(aName:String;aNodeList:TJanXMLNodeList2):TjanXMLNode2;
var
  x:Longint;
Begin
  Result := Nil;
  for x:=0 to aNodeList.Count-1 do
    Begin
      if Uppercase(aName) = Uppercase(TjanXMLNode2(aNodeList.Items[x]).name) then
        Begin
          Result := TjanXMLNode2(aNodeList.Items[x]);
          Exit;
        end;
    End;
End;

Function GetOrCreateNodeByName(aName:String;aNodeList:TJanXMLNodeList2;aDefaultValue:String = ''):TjanXMLNode2;
Begin
//
  Result := GetNodeByName(aName,aNodeList);
  if Result=nil then
    begin
      Result := TjanXMLNode2.create;
      Result.name := aName;
      Result.text := aDefaultValue;
      aNodeList.Add(Result)
    end;

End;


end.
